
// TCL Tools.cpp: 定义应用程序的类行为。
//

#include "pch.h"
#include "framework.h"
#include "TCL Copy Tool.h"
#include "TCL Copy ToolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTCLToolsApp

BEGIN_MESSAGE_MAP(CTCLToolsApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CTCLToolsApp 构造

CTCLToolsApp::CTCLToolsApp()
{
	// 支持重新启动管理器
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

	// TODO: 在此处添加构造代码，
	// 将所有重要的初始化放置在 InitInstance 中
}


// 唯一的 CTCLToolsApp 对象

CTCLToolsApp theApp;


// CTCLToolsApp 初始化

BOOL CTCLToolsApp::InitInstance()
{
// TODO: 调用 AfxInitRichEdit2() 以初始化 richedit2 库。\n"	// 如果一个运行在 Windows XP 上的应用程序清单指定要
	// 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
	//则需要 InitCommonControlsEx()。  否则，将无法创建窗口。
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// 将它设置为包括所有要在应用程序中使用的
	// 公共控件类。
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	AfxInitRichEdit2();
	CWinApp::InitInstance();

#if 1
	// 获取模块的目录;
	TCHAR szDrive[MAX_PATH] = { 0 };
	TCHAR szDir[MAX_PATH] = { 0 };
	TCHAR szExt[MAX_PATH] = { 0 };
	::GetModuleFileName(NULL, Global::g_szCurModulePath, sizeof(Global::g_szCurModulePath) / sizeof(TCHAR));
	_tsplitpath_s(Global::g_szCurModulePath, szDrive, szDir, Global::g_szFna, szExt);
	_tcscpy_s(Global::g_szCurModuleDir, szDrive);
	_tcscat_s(Global::g_szCurModuleDir, szDir);
	// config文件路径;
	_stprintf_s(Global::g_szConfig, _T("%sconfig.ini"), Global::g_szCurModuleDir);

	// 日志模板;
	char szFileName[MAX_PATH];
	sprintf_s(szFileName, "%s\\log4crc.xml", Global::g_szCurModuleDir);
	///设置日志配置文件名
	LOG4C_PARAM_CFG_FILE_NAME(szFileName);
	///设置日志级别
	LOG4C_PARAM_LOG_LEVEL("unknown");
	///设置日志文件大小
	LOG4C_PARAM_LOG_FILE_SIZE(1024*1024*10);
	///设置生成日志文件个数，达到最大个数将自动覆盖最旧的日志
	LOG4C_PARAM_LOG_FILE_NUM(100);
	///设置每次记录日志都重新读取日志配置文件
	LOG4C_PARAM_REREAD_LOG_CFG_FILE(1);
	///带参数日志模块初始化,以上所有设置了的参数都将生效，没有设置的采用缺省值
	LOG4C_INIT_WITH_PARAM();

#if 0 // 等级示例;
	LOG4C((LOG_FATAL, "LOG_FATAL!"));
	LOG4C((LOG_ALERT, "LOG_ALERT!"));
	LOG4C((LOG_CRIT, "LOG_CRIT!"));
	LOG4C((LOG_ERROR, "LOG_ERROR!"));
	LOG4C((LOG_WARN, "LOG_WARN!"));
	LOG4C((LOG_NOTICE, "LOG_NOTICE!"));
	LOG4C((LOG_INFO, "LOG_INFO!"));
	LOG4C((LOG_DEBUG, "LOG_DEBUG!"));
	LOG4C((LOG_TRACE, "LOG_TRACE!"));
	LOG4C((LOG_NOTSET, "LOG_NOTSET!"));
	LOG4C((LOG_UNKNOWN, "LOG_UNKNOWN!"));
#endif

	LOG4C((LOG_NOTICE, "程序开始运行!"));
#endif

	Global::GetConfig();
	Global::GetMacAddress();
	AfxEnableControlContainer();

	if (g_db.Open())
		g_db.RemoveReportInfo();

	// 启动线程上报;
	std::thread t([]() {
		COTA ota;
		std::string xml;
		std::vector<STReport> vt;
		while (true)
		{
			vt.clear();
			g_db.QueryUnReportInfo(vt);
			for (auto it: vt)
			{
				if (ota.GetKeyInfo(it.url, it.content, "", "", xml) )
				{
					// 上报成功;
					g_db.UpdateKeyReportStatus(it);
				}

				std::this_thread::sleep_for(std::chrono::microseconds(500));
			}
			std::this_thread::sleep_for(std::chrono::seconds(10));
		}
	});
	t.detach();
	//std::string vcode;
	//g_ota.GetVCode("CC-A1-2B-03-09-13", vcode);
	// 创建 shell 管理器，以防对话框包含
	// 任何 shell 树视图控件或 shell 列表视图控件。
	CShellManager *pShellManager = new CShellManager;

	// 激活“Windows Native”视觉管理器，以便在 MFC 控件中启用主题
	CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

	// 标准初始化
	// 如果未使用这些功能并希望减小
	// 最终可执行文件的大小，则应移除下列
	// 不需要的特定初始化例程
	// 更改用于存储设置的注册表项
	// TODO: 应适当修改该字符串，
	// 例如修改为公司或组织名
	SetRegistryKey(_T("应用程序向导生成的本地应用程序"));

	CTCLCopyToolDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: 在此放置处理何时用
		//  “确定”来关闭对话框的代码
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: 在此放置处理何时用
		//  “取消”来关闭对话框的代码
	}
	else if (nResponse == -1)
	{
		TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
		TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
	}

	// 删除上面创建的 shell 管理器。
	if (pShellManager != nullptr)
	{
		delete pShellManager;
	}

#if !defined(_AFXDLL) && !defined(_AFX_NO_MFC_CONTROLS_IN_DIALOGS)
	ControlBarCleanUp();
#endif

	// 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
	//  而不是启动应用程序的消息泵。
	return FALSE;
}



int CTCLToolsApp::ExitInstance()
{
	// TODO: 在此添加专用代码和/或调用基类
	g_db.Close();
	g_siacp.CloseComm();
	return CWinApp::ExitInstance();
}
